var landing = (function(){
	var elementPixelWidth = 0;
	
	return {
		init: function() {
			var thisRef = this;
			// on resize handle slider
			window.onresize = function(){
				thisRef.setElements();
			}
			
			// Set initial
			this.setElements();
			this.showTab(0);
			$('#category-slider li').eq(0).addClass('slick-current');

			if(window.innerWidth >= 1056){
			    this.setCategories();
			}

			// Do initial positioning of the marker
			// plug is used so marker doesn't animate from initial left 0 position
			$('.marker').addClass('plug');
			this.positionMarker(0);
			$('.marker').removeClass('plug');
			$('.marker').addClass('show');

			// update category based on click
			$('#category-slider li').click(function(e){
				if(window.innerWidth >= 1056){
					thisRef.setCategories();
					thisRef.positionMarker($(this).index());
					thisRef.showTab($(this).index());
                    
                    // pop the selected category
					$('#category-slider li').removeClass('slick-current');
					$(this).addClass('slick-current');
				}
			});
			
			$('#category-slider').on('beforeChange', function(event, slick, currentSlide, nextSlide){
				thisRef.showTab(nextSlide);
			});
		},
		setElements: function() {
		    if (window.innerWidth <= 1056 && $('#category-slider li').length > 1) {
				$('#category-slider:not(.slick-initialized)').slick({
					prevArrow: '<img class="arrow left" src="../../global/images/leftGameArrow.png">',
					nextArrow: '<img class="arrow right" src="../../global/images/rightGameArrow.png">',
					centerMode: true,
					focusOnSelect: true,
					slidesToShow: 3,
					responsive: [
						{
							breakpoint: 501,
							settings: {
								slidesToShow: 1
							}
						}
					]
				});
			}
			else {
				$('#category-slider.slick-initialized').slick('unslick');
				this.setCategories();
				this.positionMarker(0);
				this.showTab(0);
				$('#category-slider li').eq(0).addClass('slick-current');
			}
		},
		setCategories: function() {
			// get width of each element as percentage
			var wrapperWidth = $('#category-slider').innerWidth();
			elementPixelWidth = wrapperWidth / $('#category-slider').children().length;

			var elementPercentWidth = (elementPixelWidth / wrapperWidth) * 100
			$('#category-slider').children().width(elementPercentWidth + '%');
		},
		positionMarker: function(index) {
			var destination = index * elementPixelWidth;
			destination += elementPixelWidth / 2 + $('.marker').width() / 2;

			$('.marker').css('left', destination + 'px');
		},
		showTab: function(index) {
			$('#thumb-container ul').hide();
			$('#thumb-container ul').eq(index).show();
		}
	};
})();