(function () {

    var quiz = window.quiz || undefined;
    if (quiz) {

        var questionData = quiz.questionData;
        var resultData = quiz.resultData;
        var quizPath = quiz.directory;
        var checkImagePath = "../global/images/check.png";

        var answers = [];
        var transitions = false;
        var currentIndex;
        var justClicked;
        var quizSlider;
        var quizTitle;
        var quizSubtitle;
        var scrollAPI;



        $(document).ready(function () {
            try {
                if ('WebkitTransition' in document.body.style ||
                    'MozTransition' in document.body.style ||
                    'OTransition' in document.body.style ||
                    'transition' in document.body.style
                ) {
                    transitions = true;
                }

                $("#takeQuizButton").click(next);
                $("#takeQuizButton > p").html(quiz.startButtonText);
                $("#takeAgainButton").on("click touchstart", function () { start(true); });
                $("#takeAgainButton > p").html(quiz.restartButtonText);

                quizSlider = $("#quizSlider");
                quizTitle = $("#quizTitle");
                quizSubtitle = $("#quizSubtitle");
 
                start();
                var el = $(".scroll-pane").jScrollPane({ contentWidth: '0px' });
                scrollAPI = el.data("jsp");
                resize();
            }
            catch (e) { };

            //Forces locale to serif font
            if (window.location.href.indexOf('el-gr') > -1) {
                console.log('if');
                $('#quizContainer').css('font-family', 'Arial'); 
            }
        });

        $(window).on("resize", resize);
    }

    function resize() {
        var quizContainer = $("#quizContainer");
        
        var containerHeight = quizContainer.innerHeight();

        
        //portait
        if (window.innerWidth <= 660 || window.innerWidth / window.innerHeight <= 8 / 9){
            quizContainer.height(quizContainer.innerWidth() * 1.2);
            //
            if (window.innerWidth < 400){
                sizeResults(containerHeight * 0.43);
            }
            else {
                sizeResults(containerHeight * 0.6);
            }
        }
        //landscape
        else {
            quizContainer.height(quizContainer.innerWidth() * 0.75);
            sizeResults(containerHeight * 0.5);
        }
        if (scrollAPI)
            scrollAPI.reinitialise();
    }

    function sizeResults(val) {
        var pane = $(".scroll-pane");
        var textHeight = pane.children(".jspContainer").innerHeight();
        if (textHeight > val) {
            pane.height(val);
        }
        else {
            pane.height("");
        }
    }

    function start(restart) {
        if (restart) {
            if (transitions) {
                $("#resultSection").prependTo($("#quizSlider"));
                quizSlider.css("transition", "none");
                quizSlider.css("margin-left", "0");
                quizTitle.removeClass("smallText");   //allows stylesheet to regain control
                window.setTimeout(function () {
                    quizSlider.css("transition", "margin-left 0.5s ease");
                    quizSlider.css("margin-left", "-100%");
                }, 5);

                document.getElementById("quizSlider").addEventListener("transitionend", replaceLastSection);
                document.getElementById("quizSlider").addEventListener("webkitTransitionEnd", replaceLastSection);

                quizTitle.css("transition", ""); //put it back to normal
            }
            else {
                quizSlider.css("margin-left", "0");
            }
            quizTitle.css("left", "");

            window.setTimeout(function () {
                $("#secondaryTitle").addClass('initial');
            }, 500);

            if (quiz.directory == "/global/quizzes/what-is-your-dream-vacation/") {
                doTracking("Games: None: Game_Quiz What Is Your Dream Vacation", "None", "Games", "Game", "Game Replay");
            }
            else if (quiz.directory == "/global/quizzes/which-polly-pal-are-you-most-like/") {
                doTracking("Games: None: Game_Quiz Which Polly Pal Are You Most Like", "None", "Games", "Game", "Game Replay");
            }
        }
        else {
            if (quiz.directory == "../quizzes/what-is-your-dream-vacation/") {
                doTracking("Games: None: Game_Quiz What Is Your Dream Vacation", "None", "Games", "Game", "Game Play");
            }
            else if (quiz.directory == "../quizzes/which-polly-pal-are-you-most-like/") {
                doTracking("Games: None: Game_Quiz Which Polly Pal Are You Most Like", "None", "Games", "Game", "Game Play");
            }

            $("#secondaryTitle").css("transition", "none");
        }

        quizTitle.text(quiz.title);
        quizSubtitle.text(quiz.subtitle);
        answers = [];
        populateQuestions();

        $("#secondaryTitle").html(quiz.tabulatingText).css("left", "-100%");
        $(".quizOptionContainer").on('click', 'img', next);
        /*/$(".splashImage").attr("src", quizPath + quiz.splashImage);*/
        $("#landing").css("background", "url(" + quizPath + (quiz.backgroundImage ? quiz.backgroundImage : "images/background.jpg") + ") no-repeat").css("background-size", "cover");
        $("#questionBG").css("background", "url(" + quizPath + (quiz.questionBG ? quiz.questionBG : "images/question_bkgd.jpg") + ") no-repeat").css("background-size", "cover");        

        currentIndex = 0;
        justClicked = false;
    }

    function replaceLastSection(e) {
        document.getElementById("quizSlider").removeEventListener("transitionend", replaceLastSection);
        document.getElementById("quizSlider").removeEventListener("webkitTransitionEnd", replaceLastSection);
        quizSlider.css("transition", "none");
        $("#resultSection").appendTo(quizSlider);
        quizSlider.css("margin-left", "0");
        window.setTimeout(function () {
            quizSlider.css("transition", "margin-left 0.5s ease");
        }, 5);
    }

    function next(e) {
        if (justClicked) {
            return;
        }

        if (parseFloat(quizSlider.css("margin-left")) < 0) {
            if (transitions)
                quizSlider.css("transition-delay", "0.5s");
        }
        else {
            quizTitle.addClass("smallText");
        }
        if (e && $(e.target).parent().hasClass("quizOption")) {

            //get index of item
            var img = $(this);
            var index = img.parent().index();

            //store index in array of answers
            answers[currentIndex] = index;
            img.css("background", "url('" + img.attr("src") + "')").css({"background-origin": "border-box", "background-size": "cover" });
            img.attr("src", checkImagePath);
            justClicked = true;
            if (transitions) {

                document.getElementById("quizSlider").addEventListener("webkitTransitionEnd", resetButtonClicking);
                document.getElementById("quizSlider").addEventListener("transitionend", resetButtonClicking);
            }
            else {
                window.setTimeout(resetButtonClicking, 500);
            }
        }

        currentIndex++;

        //tabulating screen
        if (currentIndex === questionData.length + 1) {

            window.setTimeout(next, 2000);
            populateResults();

            if (transitions) {
                $("#secondaryTitle").css("transition", "none");
                $("#secondaryTitle").css("left", "100%");
            }

            //tween titles in and out, respectively
            window.setTimeout(function () {
                $("#secondaryTitle").css("transition", "");
                quizTitle.css("left", "-100%");
                $("#secondaryTitle").css("left", "");
            }, 500);

        }
            //results screen
        else if (currentIndex === questionData.length + 2) {
            if (transitions) {
                //discretely move quiz title to the right of the view
                quizTitle.css("transition", "none");
                quizTitle.css("left", "100%");
                window.setTimeout(function () {
                    $("#secondaryTitle").removeClass('initial');
                }, 500);
            }
        }
        var timeout = transitions ? 500 : 0;
        //update slide counter
        if (currentIndex > 0 && currentIndex <= questionData.length) {
            window.setTimeout(function () {
                $("#questionNumber").text(currentIndex + "/" + questionData.length);
            }, timeout);
        }
        else {
            window.setTimeout(function () {
                $("#questionNumber").text("");
            }, timeout);
        }

        if (transitions) {
            quizSlider.css("margin-left", currentIndex * -100 + "%");            
        } else {
            window.setTimeout(function () {
                quizSlider.css("margin-left", currentIndex * -100 + "%");
            }, 500);
        }
    }

    function resetButtonClicking(e) {
        if (e.propertyName == "margin-left") {
            if (transitions) {
                e.target.removeEventListener("webkitTransitionEnd", resetButtonClicking);
                e.target.removeEventListener("transitionend", resetButtonClicking);
            }
            justClicked = false;
        }
        
    }

    function populateQuestions() {
        var html = "";
        var numQuestions = questionData.length;

        for (var i = 0; i < questionData.length; i++) {
            html += "<div class='quizSection' style='width: " + 100 / numQuestions + "%;'>";
            html += "<h1 class='questionTitle'>" + questionData[i].questionTitle + "</h1>";
            html += "<h2 class='questionHeader'>" + questionData[i].question + "</h2>";
            html += "<div class='quizOptionContainer'>";
            for (var j = 0; j < 3; j++) {
                html += "<div class='quizOption'><img src='" + quizPath + questionData[i].answers[j] + "'></div>";
            }
            html += "</div></div>";
        }

        var sectionWidth = 100 / (numQuestions + 3);

        quizSlider.width((numQuestions + 3) * 100 + "%");
        $("#questionsContainer").width(sectionWidth * numQuestions + "%");
        $("#questionsContainer").html(html);
        $("#landing, #resultSection, #tabulating").width(sectionWidth + "%");

        quizTitle.html(quiz.title);
        $("#introText").html(quiz.introText);
    }

    function populateResults() {
        var answerCounts = [0, 0, 0, 0];
        for (var i = 0; i < answers.length; i++)
            answerCounts[answers[i]]++;
        var max = 0;
        var index = 0;
        for (var i = 0; i < 4; i++) {
            if (max < answerCounts[i]) {
                max = answerCounts[i];
                index = i;
            }
        }
        $("#resultName").html(resultData[index].name);
        $("#resultInfo").html(resultData[index].paragraph);
        $("#resultSection").css("background", "url(" + quizPath + resultData[index].image + ")").css("background-size", "cover");
        resize();
    }
})();
